<script setup>
import countries from '@/assets/countries.json'
import { ref, unref, reactive, computed, watch } from 'vue'

const question = ref('')
const answer = ref('Questions usually contain a question mark. ;-)')

// watch works directly on a ref
watch(question, async (newQuestion, oldQuestion) => {
  if (newQuestion.indexOf('?') > -1) {
    answer.value = 'Thinking...'
    try {
      const res = await fetch('https://yesno.wtf/api')
      answer.value = (await res.json()).answer
    } catch (error) {
      answer.value = 'Error! Could not reach the API. ' + error
    }
  }
})


const todoId = ref(1)
const todoData = ref(null)

async function fetchData() {
  todoData.value = null
  const res = await fetch(
    `https://jsonplaceholder.typicode.com/todos/${todoId.value}`
  )
  todoData.value = await res.json()
}

fetchData()
watch(todoId, fetchData)


const checked = ref(false)
const checkedNames = ref([])
const picked = ref(null)
const selected = ref(null)
const selectedMultiple = ref(null)

const options = ref([
  { text: 'One', value: 'A' },
  { text: 'Two', value: 'B' },
  { text: 'Three', value: 'C' }
])

const countriesOptions = ref(countries.map(
  (c) => ({ 'text': c.name, 'value': c.code })
))
const country = ref(null)
const borders = computed(() => {
  if (!unref(country)) {
    return null
  }
  return countries.filter((c) => c.code == unref(country))[0].borders
})
const neighbor = ref(null)


const coor = reactive({
  x: 1,
  y: 2,
});

watch(coor, (newCoor) => {
  console.log(`coor is ${newCoor.x}`)
})


const polar = computed(() => {
  return {
    alfa: Math.atan2(coor.y, coor.x) * 180 / Math.PI,
    d: Math.sqrt(coor.x * coor.x + coor.y * coor.y)
  }
});



</script>

<template>
  <div class="block">
    <p>
      Ask a yes/no question:
      <input v-model="question" />
    </p>
    <p>{{ answer }}</p>
  </div>
  <div class="block">
    <p>Todo id: {{ todoId }}</p>
    <button @click="todoId++">Fetch next todo</button>
    <p v-if="!todoData">Loading...</p>
    <pre v-else>{{ todoData }}</pre>
  </div>
  <div class="block">
    <label for="x">X: </label>
    <input id="x" type="number" v-model="coor.x" />,
    <label for="y">Y: </label>
    <input if="y" type="number" v-model="coor.y" />
    <hr>
    <p>
      {{ coor }} -> {{ polar }}
    </p>

  </div>
  <div class="block">
    <input type="checkbox" id="checkbox" v-model="checked" />
    <label for="checkbox">{{ checked }}</label>
  </div>
  <div class="block">
    <div>Checked names: {{ checkedNames }}</div>
    <hr />
    <input type="checkbox" id="jack" value="Jack" v-model="checkedNames">
    <label for="jack">Jack</label>
    <br>
    <input type="checkbox" id="john" value="John" v-model="checkedNames">
    <label for="john">John</label>
    <br>
    <input type="checkbox" id="mike" value="Mike" v-model="checkedNames">
    <label for="mike">Mike</label>
  </div>
  <div class="block">
    <div>Picked: {{ picked }}</div>
    <hr />
    <input type="radio" id="one" value="One" v-model="picked" />
    <label for="one">One</label>
    <br>
    <input type="radio" id="two" value="Two" v-model="picked" />
    <label for="two">Two</label>
  </div>
  <div class="block">
    <div>Selected: {{ selected }}</div>
    <hr />
    <select v-model="selected">
      <option disabled value="">Please select one</option>
      <option>A</option>
      <option>B</option>
      <option>C</option>
    </select>
  </div>
  <div class="block">\
    <div>Selected: {{ selected }}</div>
    <hr />
    <select v-model="selected" multiple>
      <option>A</option>
      <option>B</option>
      <option>C</option>
    </select>
  </div>
  <div class="block">
    <div>Selected: {{ selected }}</div>
    <hr />
    <select v-model="selected">
      <option v-for="option in options" :value="option.value">
        {{ option.text }}
      </option>
    </select>
  </div>
  <div class="block">
    <div>countires: {{ country }}</div>
    <hr />
    <select v-model="country">
      <option v-for="option in countriesOptions" :value="option.value">
        {{ option.text }}
      </option>
    </select>
    <select v-model="neighbor" v-if="country">
      <option v-for="option in borders" :value="option">
        {{ option }}
      </option>
    </select>
    <span v-else> Vyber zemi</span>
    <span v-show="country != null && neighbor != null">
      Trasa vede z {{ country }} do {{ neighbor }}.
    </span>
    <div class="block">
      <ul>
        <li v-for="country in countries" :key="country.code">
          {{ country.name }}
        </li>
      </ul>
    </div>
  </div>
</template>

<style scoped>
.block {
  padding: 10px;
}
</style>
